test-lib: --valgrind should not override --verbose-log
[git/git.git] / t / test-lib.sh
CommitLineData
c74c7203 1# Test framework for git. See t/README for usage.
e1970ce4
JH
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
3c8f12c9
JH
18# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
85176d72
FC
26else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
3c8f12c9
JH
30fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
d0cc5796
JK
39# If we were built with ASAN, it may complain about leaks
40# of program-lifetime variables. Disable it by default to lower
41# the noise level. This needs to happen at the start of the script,
42# before we even do our "did we build git yet" check (since we don't
43# want that one to complain to stderr).
bf1ce904 44: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
d0cc5796
JK
45export ASAN_OPTIONS
46
2006f0ad
RR
47################################################################
48# It appears that people try to run tests without building...
49"$GIT_BUILD_DIR/git" >/dev/null
50if test $? != 1
51then
52 echo >&2 'error: you do not seem to have built git yet.'
53 exit 1
54fi
55
3c8f12c9
JH
56. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
57export PERL_PATH SHELL_PATH
58
4cde519f
RR
59# if --tee was passed, write the output not only to the terminal, but
60# additionally to the file test-results/$BASENAME.out, too.
61case "$GIT_TEST_TEE_STARTED, $* " in
62done,*)
63 # do not redirect again
64 ;;
452320f1 65*' --tee '*|*' --va'*|*' --verbose-log '*)
2d14e13c
JK
66 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
67 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
452320f1
JK
68
69 # Make this filename available to the sub-process in case it is using
70 # --verbose-log.
71 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
72 export GIT_TEST_TEE_OUTPUT_FILE
73
74 # Truncate before calling "tee -a" to get rid of the results
75 # from any previous runs.
76 >"$GIT_TEST_TEE_OUTPUT_FILE"
77
4cde519f 78 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
452320f1 79 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
925bdc92 80 test "$(cat "$BASE.exit")" = 0
4cde519f
RR
81 exit
82 ;;
83esac
84
e1970ce4 85# For repeatability, reset the environment to known value.
d5c1b7c2 86# TERM is sanitized below, after saving color control sequences.
e1970ce4 87LANG=C
899460f3 88LC_ALL=C
d9bdd39e 89PAGER=cat
e1970ce4 90TZ=UTC
d5c1b7c2 91export LANG LC_ALL PAGER TZ
8ff99e74 92EDITOR=:
661bfd13
SL
93# A call to "unset" with no arguments causes at least Solaris 10
94# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
95# deriving from the command substitution clustered with the other
96# ones.
3c8f12c9 97unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 98 my @env = keys %ENV;
730477f1
JL
99 my $ok = join("|", qw(
100 TRACE
101 DEBUG
730477f1
JL
102 TEST
103 .*_TEST
104 PROVE
105 VALGRIND
ac001282 106 UNZIP
edb54081 107 PERF_
e2a0ccc0 108 CURL_VERBOSE
4527aa10 109 TRACE_CURL
730477f1
JL
110 ));
111 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
112 print join("\n", @vars);
113')
5adf84eb 114unset XDG_CONFIG_HOME
8bade1e1 115unset GITPERLLIB
29e55cd5
JH
116GIT_AUTHOR_EMAIL=author@example.com
117GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
118GIT_COMMITTER_EMAIL=committer@example.com
119GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 120GIT_MERGE_VERBOSITY=5
f8246281
JH
121GIT_MERGE_AUTOEDIT=no
122export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
123export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
124export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 125export EDITOR
e1970ce4 126
124647c4
KB
127# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
128GIT_TRACE_BARE=1
129export GIT_TRACE_BARE
130
5d9fc888
TG
131if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
132then
133 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
134 export GIT_INDEX_VERSION
135fi
136
a731fa91
EP
137# Add libc MALLOC and MALLOC_PERTURB test
138# only if we are not executing the test with valgrind
1b3185fc 139if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 140 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
141then
142 setup_malloc_check () {
143 : nothing
144 }
145 teardown_malloc_check () {
146 : nothing
147 }
148else
149 setup_malloc_check () {
150 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
151 export MALLOC_CHECK_ MALLOC_PERTURB_
152 }
153 teardown_malloc_check () {
154 unset MALLOC_CHECK_ MALLOC_PERTURB_
155 }
156fi
a731fa91 157
886a3907
JH
158# Protect ourselves from common misconfiguration to export
159# CDPATH into the environment
160unset CDPATH
161
5565f47c 162unset GREP_OPTIONS
ac001282 163unset UNZIP
5565f47c 164
3d5c0cc9 165case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756 1661|2|true)
025232e8 167 GIT_TRACE=4
1c0cc756 168 ;;
6ce4e61f
CC
169esac
170
cd3c095c
JH
171# Convenience
172#
173# A regexp to match 5 and 40 hexdigits
174_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
175_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
176
3749fde5
JH
177# Zero SHA-1
178_z40=0000000000000000000000000000000000000000
179
f9e7d9f8 180EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
378932d3 181EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
f9e7d9f8 182
3f4ab627
JH
183# Line feed
184LF='
185'
186
a42643aa
JK
187# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
188# when case-folding filenames
189u200c=$(printf '\342\200\214')
190
378932d3 191export _x05 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
342e9ef2 192
e1970ce4
JH
193# Each test should start with something like this, after copyright notices:
194#
195# test_description='Description of this test...
196# This test checks if command xyzzy does the right thing...
197# '
198# . ./test-lib.sh
d5c1b7c2 199test "x$TERM" != "xdumb" && (
ca92a660
RH
200 test -t 1 &&
201 tput bold >/dev/null 2>&1 &&
202 tput setaf 1 >/dev/null 2>&1 &&
203 tput sgr0 >/dev/null 2>&1
204 ) &&
205 color=t
e1970ce4 206
e1970ce4
JH
207while test "$#" -ne 0
208do
209 case "$1" in
210 -d|--d|--de|--deb|--debu|--debug)
211 debug=t; shift ;;
886856ab
JH
212 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
213 immediate=t; shift ;;
5e2c08c6 214 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 215 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
0445e6f0
IB
216 -r)
217 shift; test "$#" -ne 0 || {
218 echo 'error: -r requires an argument' >&2;
219 exit 1;
220 }
221 run_list=$1; shift ;;
222 --run=*)
0ff74101 223 run_list=${1#--*=}; shift ;;
e1970ce4 224 -h|--h|--he|--hel|--help)
570f3226 225 help=t; shift ;;
e1970ce4
JH
226 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
227 verbose=t; shift ;;
ff09af3f 228 --verbose-only=*)
0ff74101 229 verbose_only=${1#--*=}
ff09af3f 230 shift ;;
1ece1274 231 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
232 # Ignore --quiet under a TAP::Harness. Saying how many tests
233 # passed without the ok/not ok details is always an error.
234 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
235 --with-dashes)
236 with_dashes=t; shift ;;
55db1df0 237 --no-color)
faa4bc35 238 color=; shift ;;
4e1be63c 239 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
240 valgrind=memcheck
241 shift ;;
242 --valgrind=*)
0ff74101 243 valgrind=${1#--*=}
952af351 244 shift ;;
5dfc368f 245 --valgrind-only=*)
0ff74101 246 valgrind_only=${1#--*=}
5dfc368f 247 shift ;;
44138559
JS
248 --tee)
249 shift ;; # was handled already
f423ef5f 250 --root=*)
0ff74101 251 root=${1#--*=}
f423ef5f 252 shift ;;
bb79af9d
JK
253 --chain-lint)
254 GIT_TEST_CHAIN_LINT=1
255 shift ;;
256 --no-chain-lint)
257 GIT_TEST_CHAIN_LINT=0
258 shift ;;
a136f6d8
JK
259 -x)
260 trace=t
261 verbose=t
262 shift ;;
452320f1
JK
263 --verbose-log)
264 verbose_log=t
265 shift ;;
e1970ce4 266 *)
1f729dca 267 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
268 esac
269done
270
26a07309 271if test -n "$valgrind_only"
5dfc368f
TR
272then
273 test -z "$valgrind" && valgrind=memcheck
274 test -z "$verbose" && verbose_only="$valgrind_only"
275elif test -n "$valgrind"
276then
88c6e9d3 277 test -z "$verbose_log" && verbose=t
5dfc368f 278fi
952af351 279
ca92a660
RH
280if test -n "$color"
281then
d5c1b7c2
RH
282 # Save the color control sequences now rather than run tput
283 # each time say_color() is called. This is done for two
284 # reasons:
285 # * TERM will be changed to dumb
286 # * HOME will be changed to a temporary directory and tput
287 # might need to read ~/.terminfo from the original HOME
288 # directory to get the control sequences
289 # Note: This approach assumes the control sequences don't end
290 # in a newline for any terminal of interest (command
291 # substitutions strip trailing newlines). Given that most
292 # (all?) terminals in common use are related to ECMA-48, this
293 # shouldn't be a problem.
294 say_color_error=$(tput bold; tput setaf 1) # bold red
295 say_color_skip=$(tput setaf 4) # blue
296 say_color_warn=$(tput setaf 3) # brown/yellow
297 say_color_pass=$(tput setaf 2) # green
298 say_color_info=$(tput setaf 6) # cyan
299 say_color_reset=$(tput sgr0)
300 say_color_="" # no formatting for normal text
ca92a660 301 say_color () {
d5c1b7c2
RH
302 test -z "$1" && test -n "$quiet" && return
303 eval "say_color_color=\$say_color_$1"
ca92a660 304 shift
d5c1b7c2 305 printf "%s\\n" "$say_color_color$*$say_color_reset"
ca92a660
RH
306 }
307else
308 say_color() {
309 test -z "$1" && test -n "$quiet" && return
310 shift
311 printf "%s\n" "$*"
312 }
313fi
314
d5c1b7c2
RH
315TERM=dumb
316export TERM
317
55db1df0
PH
318error () {
319 say_color error "error: $*"
6e7b5aaf 320 GIT_EXIT_OK=t
55db1df0
PH
321 exit 1
322}
323
324say () {
325 say_color info "$*"
326}
327
614fe015
JK
328if test -n "$HARNESS_ACTIVE"
329then
330 if test "$verbose" = t || test -n "$verbose_only"
331 then
332 printf 'Bail out! %s\n' \
333 'verbose mode forbidden under TAP harness; try --verbose-log'
334 exit 1
335 fi
336fi
337
570f3226
MB
338test "${test_description}" != "" ||
339error "Test script did not set test_description."
340
341if test "$help" = "t"
342then
cb1aefda 343 printf '%s\n' "$test_description"
570f3226
MB
344 exit 0
345fi
346
4d9d62fa 347exec 5>&1
781f76b1 348exec 6<&0
4ecae3c8 349exec 7>&2
452320f1
JK
350if test "$verbose_log" = "t"
351then
352 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
353elif test "$verbose" = "t"
e1970ce4
JH
354then
355 exec 4>&2 3>&1
356else
357 exec 4>/dev/null 3>/dev/null
358fi
359
d88785e4
JK
360# Send any "-x" output directly to stderr to avoid polluting tests
361# which capture stderr. We can do this unconditionally since it
362# has no effect if tracing isn't turned on.
363#
364# Note that this sets up the trace fd as soon as we assign the variable, so it
365# must come after the creation of descriptor 4 above. Likewise, we must never
366# unset this, as it has the side effect of closing descriptor 4, which we
367# use to show verbose tests to the user.
368#
369# Note also that we don't need or want to export it. The tracing is local to
370# this shell, and we would not want to influence any shells we exec.
371BASH_XTRACEFD=4
372
e1970ce4
JH
373test_failure=0
374test_count=0
41ac414e
JH
375test_fixed=0
376test_broken=0
2d84e9fb 377test_success=0
e1970ce4 378
d998bd4a
ÆAB
379test_external_has_tap=0
380
faa4bc35 381die () {
6e7b5aaf
CB
382 code=$?
383 if test -n "$GIT_EXIT_OK"
384 then
385 exit $code
386 else
387 echo >&5 "FATAL: Unexpected exit with code $code"
388 exit 1
389 fi
faa4bc35
CB
390}
391
6e7b5aaf 392GIT_EXIT_OK=
35641310 393trap 'die' EXIT
da706545 394trap 'exit $?' INT
41184273 395
12a29b1a
TR
396# The user-facing functions are loaded from a separate file so that
397# test_perf subshells can have them too
3c8f12c9 398. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 399
886856ab 400# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 401# the test_expect_* functions instead.
886856ab
JH
402
403test_ok_ () {
d5d9de1b 404 test_success=$(($test_success + 1))
633fe50a 405 say_color "" "ok $test_count - $@"
e1970ce4
JH
406}
407
886856ab 408test_failure_ () {
d5d9de1b 409 test_failure=$(($test_failure + 1))
633fe50a 410 say_color error "not ok $test_count - $1"
bf0dd8a8 411 shift
cb1aefda 412 printf '%s\n' "$*" | sed -e 's/^/# /'
6e7b5aaf 413 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
414}
415
41ac414e 416test_known_broken_ok_ () {
41ac414e 417 test_fixed=$(($test_fixed+1))
633fe50a 418 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
419}
420
421test_known_broken_failure_ () {
41ac414e 422 test_broken=$(($test_broken+1))
633fe50a 423 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 424}
886856ab
JH
425
426test_debug () {
8e832ebc 427 test "$debug" = "" || eval "$1"
e1970ce4
JH
428}
429
e6a6ddc9
TR
430match_pattern_list () {
431 arg="$1"
432 shift
433 test -z "$*" && return 1
434 for pattern_
435 do
436 case "$arg" in
437 $pattern_)
438 return 0
439 esac
440 done
441 return 1
442}
443
0445e6f0
IB
444match_test_selector_list () {
445 title="$1"
446 shift
447 arg="$1"
448 shift
449 test -z "$1" && return 0
450
451 # Both commas and whitespace are accepted as separators.
452 OLDIFS=$IFS
453 IFS=' ,'
454 set -- $1
455 IFS=$OLDIFS
456
457 # If the first selector is negative we include by default.
458 include=
459 case "$1" in
460 !*) include=t ;;
461 esac
462
463 for selector
464 do
465 orig_selector=$selector
466
467 positive=t
468 case "$selector" in
469 !*)
470 positive=
471 selector=${selector##?}
472 ;;
473 esac
474
475 test -z "$selector" && continue
476
477 case "$selector" in
478 *-*)
479 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
480 then
481 echo "error: $title: invalid non-numeric in range" \
482 "start: '$orig_selector'" >&2
483 exit 1
484 fi
485 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
486 then
487 echo "error: $title: invalid non-numeric in range" \
488 "end: '$orig_selector'" >&2
489 exit 1
490 fi
491 ;;
492 *)
493 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
494 then
495 echo "error: $title: invalid non-numeric in test" \
496 "selector: '$orig_selector'" >&2
497 exit 1
498 fi
499 esac
500
501 # Short cut for "obvious" cases
502 test -z "$include" && test -z "$positive" && continue
503 test -n "$include" && test -n "$positive" && continue
504
505 case "$selector" in
506 -*)
507 if test $arg -le ${selector#-}
508 then
509 include=$positive
510 fi
511 ;;
512 *-)
513 if test $arg -ge ${selector%-}
514 then
515 include=$positive
516 fi
517 ;;
518 *-*)
519 if test ${selector%%-*} -le $arg \
520 && test $arg -le ${selector#*-}
521 then
522 include=$positive
523 fi
524 ;;
525 *)
526 if test $arg -eq $selector
527 then
528 include=$positive
529 fi
530 ;;
531 esac
532 done
533
534 test -n "$include"
535}
536
ff09af3f
TR
537maybe_teardown_verbose () {
538 test -z "$verbose_only" && return
539 exec 4>/dev/null 3>/dev/null
540 verbose=
541}
542
543last_verbose=t
544maybe_setup_verbose () {
545 test -z "$verbose_only" && return
26a07309 546 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
547 then
548 exec 4>&2 3>&1
549 # Emit a delimiting blank line when going from
550 # non-verbose to verbose. Within verbose mode the
551 # delimiter is printed by test_expect_*. The choice
552 # of the initial $last_verbose is such that before
553 # test 1, we do not print it.
554 test -z "$last_verbose" && echo >&3 ""
555 verbose=t
556 else
557 exec 4>/dev/null 3>/dev/null
558 verbose=
559 fi
560 last_verbose=$verbose
561}
562
5dfc368f
TR
563maybe_teardown_valgrind () {
564 test -z "$GIT_VALGRIND" && return
565 GIT_VALGRIND_ENABLED=
566}
567
568maybe_setup_valgrind () {
569 test -z "$GIT_VALGRIND" && return
26a07309 570 if test -z "$valgrind_only"
5dfc368f
TR
571 then
572 GIT_VALGRIND_ENABLED=t
573 return
574 fi
575 GIT_VALGRIND_ENABLED=
576 if match_pattern_list $test_count $valgrind_only
577 then
578 GIT_VALGRIND_ENABLED=t
579 fi
580}
581
9b5fe78b
JK
582want_trace () {
583 test "$trace" = t && test "$verbose" = t
584}
585
a136f6d8
JK
586# This is a separate function because some tests use
587# "return" to end a test_expect_success block early
588# (and we want to make sure we run any cleanup like
589# "set +x").
590test_eval_inner_ () {
591 # Do not add anything extra (including LF) after '$*'
592 eval "
9b5fe78b 593 want_trace && set -x
a136f6d8
JK
594 $*"
595}
596
a7c58f28 597test_eval_ () {
a136f6d8
JK
598 # We run this block with stderr redirected to avoid extra cruft
599 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
600 # the shell from printing the "set +x" to turn it off (nor the saving
601 # of $? before that). But we can make sure that the output goes to
602 # /dev/null.
603 #
604 # The test itself is run with stderr put back to &4 (so either to
605 # /dev/null, or to the original stderr if --verbose was used).
606 {
607 test_eval_inner_ "$@" </dev/null >&3 2>&4
608 test_eval_ret_=$?
9b5fe78b 609 if want_trace
a136f6d8
JK
610 then
611 set +x
612 if test "$test_eval_ret_" != 0
613 then
614 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
615 fi
616 fi
617 } 2>/dev/null
618 return $test_eval_ret_
a7c58f28
JN
619}
620
4d9d62fa 621test_run_ () {
b6b0afdc 622 test_cleanup=:
b586744a 623 expecting_failure=$2
bb79af9d 624
92b269f5 625 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
2a01ef8c
JK
626 # turn off tracing for this test-eval, as it simply creates
627 # confusing noise in the "-x" output
628 trace_tmp=$trace
629 trace=
bb79af9d
JK
630 # 117 is magic because it is unlikely to match the exit
631 # code of other programs
99a64e4b
JH
632 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
633 then
634 error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
bb79af9d 635 fi
2a01ef8c 636 trace=$trace_tmp
bb79af9d
JK
637 fi
638
a57397b0 639 setup_malloc_check
a7c58f28 640 test_eval_ "$1"
b6b0afdc 641 eval_ret=$?
a57397b0 642 teardown_malloc_check
b586744a 643
a136f6d8
JK
644 if test -z "$immediate" || test $eval_ret = 0 ||
645 test -n "$expecting_failure" && test "$test_cleanup" != ":"
b586744a 646 then
1b3185fc 647 setup_malloc_check
a7c58f28 648 test_eval_ "$test_cleanup"
1b3185fc 649 teardown_malloc_check
b586744a 650 fi
1c0cc756
RJ
651 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
652 then
57e1538a
ÆAB
653 echo ""
654 fi
aa0bcf96 655 return "$eval_ret"
4d9d62fa
PR
656}
657
ae75342c 658test_start_ () {
8586f98b 659 test_count=$(($test_count+1))
ff09af3f 660 maybe_setup_verbose
5dfc368f 661 maybe_setup_valgrind
ae75342c
TR
662}
663
664test_finish_ () {
665 echo >&3 ""
5dfc368f 666 maybe_teardown_valgrind
ff09af3f 667 maybe_teardown_verbose
ae75342c
TR
668}
669
670test_skip () {
04ece593 671 to_skip=
ef2ac68d 672 skipped_reason=
e6a6ddc9
TR
673 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
674 then
675 to_skip=t
ef2ac68d 676 skipped_reason="GIT_SKIP_TESTS"
e6a6ddc9 677 fi
05236a5e
JN
678 if test -z "$to_skip" && test -n "$test_prereq" &&
679 ! test_have_prereq "$test_prereq"
a7bb3940
JS
680 then
681 to_skip=t
ef2ac68d 682
07431fc8 683 of_prereq=
05236a5e 684 if test "$missing_prereq" != "$test_prereq"
07431fc8 685 then
05236a5e 686 of_prereq=" of $test_prereq"
07431fc8 687 fi
ef2ac68d
IB
688 skipped_reason="missing $missing_prereq${of_prereq}"
689 fi
0445e6f0
IB
690 if test -z "$to_skip" && test -n "$run_list" &&
691 ! match_test_selector_list '--run' $test_count "$run_list"
692 then
693 to_skip=t
694 skipped_reason="--run"
695 fi
07431fc8 696
ef2ac68d
IB
697 case "$to_skip" in
698 t)
633fe50a 699 say_color skip >&3 "skipping test: $@"
ef2ac68d 700 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
04ece593
JH
701 : true
702 ;;
703 *)
704 false
705 ;;
706 esac
707}
708
342e9ef2
TR
709# stub; perf-lib overrides it
710test_at_end_hook_ () {
711 :
712}
713
e1970ce4 714test_done () {
6e7b5aaf 715 GIT_EXIT_OK=t
2d84e9fb 716
1c0cc756
RJ
717 if test -z "$HARNESS_ACTIVE"
718 then
342e9ef2 719 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 720 mkdir -p "$test_results_dir"
dd78478f 721 base=${0##*/}
5c885c1b 722 test_results_path="$test_results_dir/${base%.sh}.counts"
8ef1abe5 723
5c885c1b 724 cat >"$test_results_path" <<-EOF
c54e6be7
ML
725 total $test_count
726 success $test_success
727 fixed $test_fixed
728 broken $test_broken
729 failed $test_failure
730
731 EOF
8ef1abe5 732 fi
41ac414e
JH
733
734 if test "$test_fixed" != 0
735 then
633fe50a 736 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
737 fi
738 if test "$test_broken" != 0
739 then
633fe50a 740 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
741 fi
742 if test "$test_broken" != 0 || test "$test_fixed" != 0
743 then
744 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
745 msg="remaining $test_remaining test(s)"
11d54b8b 746 else
b73d9a23 747 test_remaining=$test_count
11d54b8b 748 msg="$test_count test(s)"
41ac414e 749 fi
e1970ce4 750 case "$test_failure" in
10b94e28 751 0)
1c0cc756
RJ
752 if test $test_external_has_tap -eq 0
753 then
b73d9a23 754 if test $test_remaining -gt 0
d87bd7c1 755 then
633fe50a 756 say_color pass "# passed all $msg"
d87bd7c1 757 fi
c7018be5
JH
758
759 # Maybe print SKIP message
760 test -z "$skip_all" || skip_all="# SKIP $skip_all"
761 case "$test_count" in
762 0)
763 say "1..$test_count${skip_all:+ $skip_all}"
764 ;;
765 *)
766 test -z "$skip_all" ||
767 say_color warn "$skip_all"
768 say "1..$test_count"
769 ;;
770 esac
d998bd4a 771 fi
abc5d372 772
06478dab 773 if test -z "$debug"
4d0912a2 774 then
06478dab 775 test -d "$TRASH_DIRECTORY" ||
4d0912a2 776 error "Tests passed but trash directory already removed before test cleanup; aborting"
abc5d372 777
06478dab
JH
778 cd "$TRASH_DIRECTORY/.." &&
779 rm -fr "$TRASH_DIRECTORY" ||
4d0912a2 780 error "Tests passed but test cleanup failed; aborting"
4d0912a2 781 fi
342e9ef2
TR
782 test_at_end_hook_
783
e1970ce4
JH
784 exit 0 ;;
785
786 *)
1c0cc756
RJ
787 if test $test_external_has_tap -eq 0
788 then
633fe50a
TR
789 say_color error "# failed $test_failure among $msg"
790 say "1..$test_count"
d998bd4a 791 fi
5099b99d 792
e1970ce4
JH
793 exit 1 ;;
794
795 esac
796}
797
e4597aae 798if test -n "$valgrind"
4e1be63c 799then
4e1be63c
JS
800 make_symlink () {
801 test -h "$2" &&
802 test "$1" = "$(readlink "$2")" || {
803 # be super paranoid
804 if mkdir "$2".lock
805 then
806 rm -f "$2" &&
807 ln -s "$1" "$2" &&
808 rm -r "$2".lock
809 else
810 while test -d "$2".lock
811 do
812 say "Waiting for lock on $2."
813 sleep 1
814 done
815 fi
816 }
817 }
818
819 make_valgrind_symlink () {
36bfb0e5 820 # handle only executables, unless they are shell libraries that
11d62145 821 # need to be in the exec-path.
36bfb0e5 822 test -x "$1" ||
11d62145 823 test "# " = "$(head -c 2 <"$1")" ||
36bfb0e5 824 return;
4e1be63c
JS
825
826 base=$(basename "$1")
28fab7b2
RS
827 case "$base" in
828 test-*)
829 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
830 ;;
831 *)
832 symlink_target="$GIT_BUILD_DIR/$base"
833 ;;
834 esac
4e1be63c
JS
835 # do not override scripts
836 if test -x "$symlink_target" &&
837 test ! -d "$symlink_target" &&
838 test "#!" != "$(head -c 2 < "$symlink_target")"
839 then
840 symlink_target=../valgrind.sh
841 fi
efd92ffd
JS
842 case "$base" in
843 *.sh|*.perl)
844 symlink_target=../unprocessed-script
845 esac
4e1be63c
JS
846 # create the link, or replace it if it is out of date
847 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
848 }
849
26a07309
TR
850 # override all git executables in TEST_DIRECTORY/..
851 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
852 mkdir -p "$GIT_VALGRIND"/bin
503e2241 853 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
26a07309
TR
854 do
855 make_valgrind_symlink $file
856 done
857 # special-case the mergetools loadables
858 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
859 OLDIFS=$IFS
860 IFS=:
861 for path in $PATH
862 do
863 ls "$path"/git-* 2> /dev/null |
864 while read file
ad0e6233 865 do
26a07309 866 make_valgrind_symlink "$file"
ad0e6233 867 done
26a07309
TR
868 done
869 IFS=$OLDIFS
4e1be63c
JS
870 PATH=$GIT_VALGRIND/bin:$PATH
871 GIT_EXEC_PATH=$GIT_VALGRIND/bin
872 export GIT_VALGRIND
952af351
TR
873 GIT_VALGRIND_MODE="$valgrind"
874 export GIT_VALGRIND_MODE
5dfc368f 875 GIT_VALGRIND_ENABLED=t
26a07309 876 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 877 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
878elif test -n "$GIT_TEST_INSTALLED"
879then
e4597aae
MO
880 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
881 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 882 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
883 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
884else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 885 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
886 if ! test -x "$git_bin_dir/git"
887 then
888 if test -z "$with_dashes"
889 then
e4597aae
MO
890 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
891 fi
892 with_dashes=t
893 fi
894 PATH="$git_bin_dir:$PATH"
6cec5c68 895 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
896 if test -n "$with_dashes"
897 then
6cec5c68 898 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 899 fi
4e1be63c 900fi
6cec5c68 901GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 902GIT_CONFIG_NOSYSTEM=1
3c995beb 903GIT_ATTR_NOSYSTEM=1
8f323c00 904export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 905
5e87eae9
JH
906if test -z "$GIT_TEST_CMP"
907then
908 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
909 then
910 GIT_TEST_CMP="$DIFF -c"
911 else
912 GIT_TEST_CMP="$DIFF -u"
913 fi
914fi
915
6cec5c68 916GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 917export GITPERLLIB
6cec5c68 918test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
919 error "You haven't built things yet, have you?"
920}
e1970ce4 921
e6e7530d 922if ! test -x "$GIT_BUILD_DIR"/t/helper/test-chmtime
1c0cc756 923then
56cf9806 924 echo >&2 'You need to build test-chmtime:'
e6e7530d 925 echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
56cf9806
EW
926 exit 1
927fi
928
e1970ce4 929# Test repository
002d4ce8
JK
930TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
931test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
932case "$TRASH_DIRECTORY" in
933/*) ;; # absolute path is good
934 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 935esac
38b074de 936rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 937 GIT_EXIT_OK=t
8d14ac94
JH
938 echo >&5 "FATAL: Cannot prepare test area"
939 exit 1
940}
941
90cff968 942HOME="$TRASH_DIRECTORY"
0ea47f9d
JH
943GNUPGHOME="$HOME/gnupg-home-not-used"
944export HOME GNUPGHOME
90cff968 945
1c0cc756
RJ
946if test -z "$TEST_NO_CREATE_REPO"
947then
38b074de 948 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 949else
38b074de 950 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 951fi
1bd9c648
LW
952# Use -P to resolve symlinks in our working directory so that the cwd
953# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 954cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 955
d5d9de1b
JS
956this_test=${0##*/}
957this_test=${this_test%%-*}
e6a6ddc9
TR
958if match_pattern_list "$this_test" $GIT_SKIP_TESTS
959then
960 say_color info >&3 "skipping test $this_test altogether"
961 skip_all="skip all tests in $this_test"
962 test_done
963fi
f17e9fbb 964
8648732e
BC
965# Provide an implementation of the 'yes' utility
966yes () {
967 if test $# = 0
968 then
969 y=y
970 else
971 y="$*"
972 fi
973
6129c930
JS
974 i=0
975 while test $i -lt 99
8648732e 976 do
6129c930
JS
977 echo "$y"
978 i=$(($i+1))
8648732e
BC
979 done
980}
981
f17e9fbb 982# Fix some commands on Windows
d98b2c5f
JS
983uname_s=$(uname -s)
984case $uname_s in
f17e9fbb
JS
985*MINGW*)
986 # Windows has its own (incompatible) sort and find
987 sort () {
988 /usr/bin/sort "$@"
989 }
990 find () {
991 /usr/bin/find "$@"
992 }
4114156a
JS
993 # git sees Windows-style pwd
994 pwd () {
995 builtin pwd -W
996 }
ee9fb68c 997 # no POSIX permissions
6fd1106a 998 # backslashes in pathspec are converted to '/'
fb9a2bea 999 # exec does not inherit the PID
a94114ad 1000 test_set_prereq MINGW
5f4e02e5 1001 test_set_prereq NATIVE_CRLF
a31d0665 1002 test_set_prereq SED_STRIPS_CR
97669eed 1003 test_set_prereq GREP_STRIPS_CR
4d715ac0 1004 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
1005 ;;
1006*CYGWIN*)
1007 test_set_prereq POSIXPERM
a31d0665 1008 test_set_prereq EXECKEEPSPID
cfa96496 1009 test_set_prereq CYGWIN
a31d0665 1010 test_set_prereq SED_STRIPS_CR
97669eed 1011 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
1012 ;;
1013*)
1014 test_set_prereq POSIXPERM
6fd1106a 1015 test_set_prereq BSLASHPSPEC
fb9a2bea 1016 test_set_prereq EXECKEEPSPID
f17e9fbb
JS
1017 ;;
1018esac
704a3143 1019
b082687c 1020( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 1021test -z "$NO_PERL" && test_set_prereq PERL
68c7d276 1022test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
d4e1b47a 1023test -z "$NO_PYTHON" && test_set_prereq PYTHON
94da9193 1024test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
5e9637c6 1025test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 1026
bb946bba 1027# Can we rely on git's output in the C locale?
30955229
JN
1028if test -n "$GETTEXT_POISON"
1029then
1030 GIT_GETTEXT_POISON=YesPlease
1031 export GIT_GETTEXT_POISON
5e9637c6 1032 test_set_prereq GETTEXT_POISON
30955229
JN
1033else
1034 test_set_prereq C_LOCALE_OUTPUT
1035fi
bb946bba 1036
cabdee2c
JH
1037# Use this instead of test_cmp to compare files that contain expected and
1038# actual output from git commands that can be translated. When running
1039# under GETTEXT_POISON this pretends that the command produced expected
1040# results.
1041test_i18ncmp () {
1042 test -n "$GETTEXT_POISON" || test_cmp "$@"
1043}
1044
127df8c6
JH
1045# Use this instead of "grep expected-string actual" to see if the
1046# output from a git command that can be translated either contains an
1047# expected string, or does not contain an unwanted one. When running
1048# under GETTEXT_POISON this pretends that the command produced expected
1049# results.
1050test_i18ngrep () {
1051 if test -n "$GETTEXT_POISON"
1052 then
1053 : # pretend success
1054 elif test "x!" = "x$1"
1055 then
1056 shift
1057 ! grep "$@"
1058 else
1059 grep "$@"
1060 fi
1061}
1062
20073274
AS
1063test_lazy_prereq PIPE '
1064 # test whether the filesystem supports FIFOs
9443605b 1065 case $(uname -s) in
a1f32964 1066 CYGWIN*|MINGW*)
9443605b
ML
1067 false
1068 ;;
1069 *)
1070 rm -f testfifo && mkfifo testfifo
1071 ;;
1072 esac
20073274
AS
1073'
1074
04083f27
JH
1075test_lazy_prereq SYMLINKS '
1076 # test whether the filesystem supports symbolic links
1077 ln -s x y && test -h y
1078'
c91cfd19 1079
b018c735
JN
1080test_lazy_prereq FILEMODE '
1081 test "$(git config --bool core.filemode)" = true
1082'
1083
ac39aa61
MG
1084test_lazy_prereq CASE_INSENSITIVE_FS '
1085 echo good >CamelCase &&
1086 echo bad >camelcase &&
1087 test "$(cat CamelCase)" != good
1088'
1089
5b0b5dd4
MG
1090test_lazy_prereq UTF8_NFD_TO_NFC '
1091 # check whether FS converts nfd unicode to nfc
1092 auml=$(printf "\303\244")
1093 aumlcdiar=$(printf "\141\314\210")
1094 >"$auml" &&
1095 case "$(echo *)" in
1096 "$aumlcdiar")
1097 true ;;
1098 *)
1099 false ;;
1100 esac
1101'
1102
09feffb6
JK
1103test_lazy_prereq AUTOIDENT '
1104 sane_unset GIT_AUTHOR_NAME &&
1105 sane_unset GIT_AUTHOR_EMAIL &&
1106 git var GIT_AUTHOR_IDENT
1107'
1108
6219bb22
JH
1109test_lazy_prereq EXPENSIVE '
1110 test -n "$GIT_TEST_LONG"
1111'
1112
e1ecd9e3
JH
1113test_lazy_prereq USR_BIN_TIME '
1114 test -x /usr/bin/time
1115'
1116
1767c517
JK
1117test_lazy_prereq NOT_ROOT '
1118 uid=$(id -u) &&
1119 test "$uid" != 0
1120'
1121
63b747ce
JT
1122test_lazy_prereq JGIT '
1123 type jgit
1124'
1125
719c3da2
JH
1126# SANITY is about "can you correctly predict what the filesystem would
1127# do by only looking at the permission bits of the files and
1128# directories?" A typical example of !SANITY is running the test
1129# suite as root, where a test may expect "chmod -r file && cat file"
1130# to fail because file is supposed to be unreadable after a successful
1131# chmod. In an environment (i.e. combination of what filesystem is
1132# being used and who is running the tests) that lacks SANITY, you may
1133# be able to delete or create a file when the containing directory
1134# doesn't have write permissions, or access a file even if the
1135# containing directory doesn't have read or execute permissions.
1136
f400e51c
TB
1137test_lazy_prereq SANITY '
1138 mkdir SANETESTD.1 SANETESTD.2 &&
1139
1140 chmod +w SANETESTD.1 SANETESTD.2 &&
1141 >SANETESTD.1/x 2>SANETESTD.2/x &&
1142 chmod -w SANETESTD.1 &&
719c3da2 1143 chmod -r SANETESTD.1/x &&
f400e51c
TB
1144 chmod -rx SANETESTD.2 ||
1145 error "bug in test sript: cannot prepare SANETESTD"
1146
719c3da2 1147 ! test -r SANETESTD.1/x &&
f400e51c
TB
1148 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1149 status=$?
1150
1151 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1152 rm -rf SANETESTD.1 SANETESTD.2 ||
1153 error "bug in test sript: cannot clean SANETESTD"
1154 return $status
1155'
f838ce58 1156
d98b2c5f 1157test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
f838ce58
JK
1158GIT_UNZIP=${GIT_UNZIP:-unzip}
1159test_lazy_prereq UNZIP '
1160 "$GIT_UNZIP" -v
1161 test $? -ne 127
1162'
9a308de3
JK
1163
1164run_with_limited_cmdline () {
1165 (ulimit -s 128 && "$@")
1166}
1167
1168test_lazy_prereq CMDLINE_LIMIT 'run_with_limited_cmdline true'
6b9c38e1
JK
1169
1170build_option () {
1171 git version --build-options |
1172 sed -ne "s/^$1: //p"
1173}
1174
1175test_lazy_prereq LONG_IS_64BIT '
1176 test 8 -le "$(build_option sizeof-long)"
1177'
a07fb050
JS
1178
1179test_lazy_prereq TIME_IS_64BIT 'test-date is64bit'
efac8ac8 1180test_lazy_prereq TIME_T_IS_64BIT 'test-date time_t-is64bit'